require 'spec_helper'

class RMDummyClass
  include QueryInterface::Client::Resource
end

describe QueryInterface::Client::Resource do

  let(:lazy_query) { double("LazyQuery") }
  before(:each) do
    allow(QueryInterface::Client::LazyQuery).to receive_messages(new: lazy_query)
  end
  context "class methods" do
    context ".query" do
      it "returns a LazyQuery object" do
        expect(RMDummyClass.query).to eq(lazy_query)
      end
    end
    context ".first" do
      it "queries the query object" do
        args = double("Args")
        expect(lazy_query).to receive(:order).with('id').and_return(lazy_query)
        expect(lazy_query).to receive(:first)
        RMDummyClass.first(args)
      end
    end
    context ".last" do
      it "queries the query object" do
        args = double("Args")
        expect(lazy_query).to receive(:order).with('id').and_return(lazy_query)
        expect(lazy_query).to receive(:last)
        RMDummyClass.last(args)
      end
    end
  end
end
